<?php
 
 
 

namespace PhpWA\Protocol\Proto;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class UserReceipt extends \Google\Protobuf\Internal\Message
{
    


    protected $userJid = null;
    


    protected $receiptTimestamp = null;
    


    protected $readTimestamp = null;
    


    protected $playedTimestamp = null;
    


    private $pendingDeviceJid;
    


    private $deliveredDeviceJid;

    













    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getUserJid()
    {
        return isset($this->userJid) ? $this->userJid : '';
    }

    public function hasUserJid()
    {
        return isset($this->userJid);
    }

    public function clearUserJid()
    {
        unset($this->userJid);
    }

    




    public function setUserJid($var)
    {
        GPBUtil::checkString($var, True);
        $this->userJid = $var;

        return $this;
    }

    



    public function getReceiptTimestamp()
    {
        return isset($this->receiptTimestamp) ? $this->receiptTimestamp : 0;
    }

    public function hasReceiptTimestamp()
    {
        return isset($this->receiptTimestamp);
    }

    public function clearReceiptTimestamp()
    {
        unset($this->receiptTimestamp);
    }

    




    public function setReceiptTimestamp($var)
    {
        GPBUtil::checkInt64($var);
        $this->receiptTimestamp = $var;

        return $this;
    }

    



    public function getReadTimestamp()
    {
        return isset($this->readTimestamp) ? $this->readTimestamp : 0;
    }

    public function hasReadTimestamp()
    {
        return isset($this->readTimestamp);
    }

    public function clearReadTimestamp()
    {
        unset($this->readTimestamp);
    }

    




    public function setReadTimestamp($var)
    {
        GPBUtil::checkInt64($var);
        $this->readTimestamp = $var;

        return $this;
    }

    



    public function getPlayedTimestamp()
    {
        return isset($this->playedTimestamp) ? $this->playedTimestamp : 0;
    }

    public function hasPlayedTimestamp()
    {
        return isset($this->playedTimestamp);
    }

    public function clearPlayedTimestamp()
    {
        unset($this->playedTimestamp);
    }

    




    public function setPlayedTimestamp($var)
    {
        GPBUtil::checkInt64($var);
        $this->playedTimestamp = $var;

        return $this;
    }

    



    public function getPendingDeviceJid()
    {
        return $this->pendingDeviceJid;
    }

    




    public function setPendingDeviceJid($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->pendingDeviceJid = $arr;

        return $this;
    }

    



    public function getDeliveredDeviceJid()
    {
        return $this->deliveredDeviceJid;
    }

    




    public function setDeliveredDeviceJid($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->deliveredDeviceJid = $arr;

        return $this;
    }

}

